--Ʒ
IF EXISTS(SELECT 1 FROM sysobjects WHERE id = OBJECT_ID('BL_HV_PresentDetailSaveToTemp'))
  DROP PROCEDURE BL_HV_PresentDetailSaveToTemp
GO

CREATE PROCEDURE BL_HV_PresentDetailSaveToTemp
(
	@ParentWineListDetailID INT,  --ƷID
	@DetailString NVARCHAR(4000),  --Ʒ:ID#ID1|ƷID1|1|̯ۼ1|ζ1|...|IDn|ƷIDn|n|̯ۼn|ζn|
	@ErrorCode INT OUTPUT,
	@ErrorMessage NVARCHAR(100) OUTPUT,
	@ExceptMessage NVARCHAR(1000) OUTPUT,
	@WineCardID INT = 0,
	@HungStatus TINYINT = 0,  --@HungStatus ʾƷƷ״̬ 0 1 2Ӽ
	@OldOpenPresentID INT = -1 --ʱԭƷID
)
AS
BEGIN
	DECLARE
		@RoomID INT,
		@CheckOutID INT,
		@MachineIP NVARCHAR(100),
		@AppTag INT,
		@PresentSign INT,
		@PresentManID INT,
		
		@Ind INT,
		@WinePresentSetID INT,
		@GroupID INT,
		@MaterialID INT,
		@OrderNumber NUMERIC(11,2),
		@DetailPrice MONEY,
		@OrderRemark NVARCHAR(100),
		@RequestAdvanceMoney MONEY,
		@MealDetailAdvanceMoney Money,
		@AdvanceMoneyTotal MONEY,    --ƷӼۺͿζӼܶ
		
		@WineListID INT,
		@WineListDetailID INT,
		@WineListType INT,
		
		@PriceTypeID INT,  --۸ID
		@CheckOutPrice MONEY,  --ԭʼ
		@ProduceTypeID INT,  --Ʒʽ
		@ProduceIP NVARCHAR(100),  --ƷIP
		@StorageID INT,  --ֿID
		@CheckActivityID INT,  --˵IDƷʱҪ¼
		@ParentTotalMoney MONEY,  --Ʒϼƽ
		@MealParentTotalMoney MONEY,  --Ʒ+ζӼ۵ĺϼƽ
		@ChildTotalMoney MONEY,  --Ʒϼƽ
		@ParentSignArtificial TINYINT,  --Ʒ 0 1
		@KeyID INT,
		@OldParentWinelistID INT, --ԭƷϸID
		@OldOrderNumber NUMERIC(11,2), --ԭƷϸ
		@NoProduce INT,
		@MealOrderNumber NUMERIC(11,2) --ײ͵㵥
	
	DECLARE @DetailTable TABLE(KeyID INT NOT NULL IDENTITY(1,1), GroupID INT, MaterialID INT, OrderNumber INT, CheckOutPrice MONEY, 
			DetailPrice MONEY, OrderRemark NVARCHAR(100), NoProduce INT NOT NULL DEFAULT 0, RequestAdvanceMoney MONEY, MealDetailAdvanceMoney MONEY)
	DECLARE @OldDetailTable TABLE(MaterialID INT, OrderNumber NUMERIC(11,2))
	
	SET @ErrorCode = -1
	SET @ErrorMessage = N''
	SET @ExceptMessage = N''
	
	set @AdvanceMoneyTotal = 0
	
	--ƷȡϢ
	SELECT @RoomID = a.RoomID, @CheckOutID = a.CheckOutID, @MachineIP = a.TempMachineIP, @AppTag = a.TempAppTag, 
		   @PriceTypeID = b.PriceTypeID, @PresentSign = b.PresentSign, @PresentManID = b.PresentManID,
		   @CheckActivityID = b.CheckActivityID, @WineListType = a.WineListType,
		   @MealParentTotalMoney = (b.ProfitPrice * b.OrderNumber), @ParentSignArtificial = b.SignArtificial,
		   @MealOrderNumber = b.OrderNumber
	  FROM BL_TBL_WineList_Master a JOIN BL_TBL_WineList_Detail b ON a.WinelistID = b.WineListID
	 WHERE WineListDetailID = @ParentWineListDetailID
	
	BEGIN TRY
		BEGIN TRAN
		
		--ƷµƷ
		--Ʒ:ID#ID1|ƷID1|1|̯ۼ1|ζ1|...|IDn|ƷIDn|n|̯ۼn|ζn|
		--ID
		SET @Ind = CHARINDEX('#', @DetailString)
		SET @WinePresentSetID = CAST(SUBSTRING(@DetailString, 1, @Ind-1) AS INT)
		SET @DetailString = SUBSTRING(@DetailString, @Ind+1, LEN(@DetailString)-@Ind)
		
		--ѷIDǵײƷ
		UPDATE BL_TBL_WineList_Detail SET WinePresentSetID = @WinePresentSetID WHERE WineListDetailID = @ParentWineListDetailID
		
		IF ISNULL(@OldOpenPresentID, 0) > 0
		BEGIN
			SELECT TOP 1 @OldParentWinelistID = a.WineListDetailID
			FROM   BL_TBL_WineList_Detail a
				   JOIN BL_TBL_WineList_Master b
						ON  a.WineListID = b.WineListID
			WHERE a.WineListType = 6 AND b.WinelistType = 2
				   AND a.MaterialID = @OldOpenPresentID
				   AND a.MealType = 1
				   --AND a.OrderNumber + a.QuitNumber = 0 --ѾƷ
				   --AND b.CheckoutID = @CheckoutID
				   AND ABS(TempAppTag) = ABS(@AppTag)
				   AND TempMachineIp = @MachineIP
			ORDER BY WineListDetailID DESC
			
			--ԭƷϸ
			INSERT INTO @OldDetailTable(MaterialID, OrderNumber)
			SELECT MaterialID, SUM(OrderNumber) * -1
			FROM BL_TBL_WineList_Detail a
			WHERE ParentWineListDetailID = @OldParentWinelistID
				AND PresentStatus = 2 
				AND EXISTS(SELECT 1 FROM BL_TBL_WineList_Detail WHERE WineListDetailID = a.QuitWineListDetailID
					AND ProduceSign = 1)
			GROUP BY MaterialID
			
		END
		
		WHILE @DetailString <> ''
		BEGIN
			--ID
			SET @Ind = CHARINDEX('|', @DetailString)
			SET @GroupID = CAST(SUBSTRING(@DetailString, 1, @Ind-1) AS INT)
			SET @DetailString = SUBSTRING(@DetailString, @Ind+1, LEN(@DetailString)-@Ind)
			
			--ƷID
			SET @Ind = CHARINDEX('|', @DetailString)
			SET @MaterialID = CAST(SUBSTRING(@DetailString, 1, @Ind-1) AS INT)
			SET @DetailString = SUBSTRING(@DetailString, @Ind+1, LEN(@DetailString)-@Ind)
			
			--
			SET @Ind = CHARINDEX('|', @DetailString)
			SET @OrderNumber = CAST(SUBSTRING(@DetailString, 1, @Ind-1) AS NUMERIC(11,2))
			SET @DetailString = SUBSTRING(@DetailString, @Ind+1, LEN(@DetailString)-@Ind)
			
			--̯ۼ
			SET @Ind = CHARINDEX('|', @DetailString)
			SET @DetailPrice = CAST(SUBSTRING(@DetailString, 1, @Ind-1) AS MONEY)
			SET @DetailString = SUBSTRING(@DetailString, @Ind+1, LEN(@DetailString)-@Ind)
			
			--ζ
			SET @Ind = CHARINDEX('|', @DetailString)
			SET @OrderRemark = SUBSTRING(@DetailString, 1, @Ind-1)
			SET @DetailString = SUBSTRING(@DetailString, @Ind+1, LEN(@DetailString)-@Ind)
			
			IF CHARINDEX('|&', @DetailString) > 0
			begin
				--ζӼ
				SET @Ind = CHARINDEX('|&', @DetailString)
				SET @RequestAdvanceMoney = CAST(SUBSTRING(@DetailString, 2, @Ind-2) AS MONEY)
				SET @DetailString = SUBSTRING(@DetailString, @Ind+1, LEN(@DetailString)-@Ind)
				
				--ƷӼ
				SET @Ind = CHARINDEX('|', @DetailString)
				SET @MealDetailAdvanceMoney = CAST(SUBSTRING(@DetailString, 2, @Ind-2) AS MONEY)
				SET @DetailString = SUBSTRING(@DetailString, @Ind+1, LEN(@DetailString)-@Ind)
			END
			SET @RequestAdvanceMoney = ISNULL(@RequestAdvanceMoney, 0)
		    SET @MealDetailAdvanceMoney = ISNULL(@MealDetailAdvanceMoney, 0)
			
			--ȡƷ۸
			EXEC BL_HV_GetWinePrice
				@MaterialID,
				@PriceTypeID,
				@CheckOutPrice OUTPUT,
				@ErrorCode OUTPUT,
				@ErrorMessage OUTPUT,
				@ExceptMessage OUTPUT
			
			IF @ErrorCode <> 0
			BEGIN
				IF (@@TRANCOUNT > 1) AND (XACT_STATE() = 1)
					COMMIT TRAN 
				ELSE
				IF  (XACT_STATE() <> 0)
					ROLLBACK TRAN 
				
				RETURN @ErrorCode
			END
			ELSE
				SET @ErrorCode = -1
		
			IF EXISTS(SELECT 1 FROM @OldDetailTable WHERE MaterialID = @MaterialID)
			BEGIN
				SELECT @OldOrderNumber = OrderNumber 
				FROM @OldDetailTable
				WHERE MaterialID = @MaterialID 
				
				IF @OldOrderNumber >= @OrderNumber --ԭײеʱ򣬶ҪƷ
				BEGIN
					INSERT INTO @DetailTable (GroupID, MaterialID, OrderNumber, CheckOutPrice, DetailPrice, OrderRemark, NoProduce, RequestAdvanceMoney, MealDetailAdvanceMoney)
					VALUES(@GroupID, @MaterialID, @OrderNumber, @CheckOutPrice, 0, @OrderRemark, 1, @RequestAdvanceMoney, @MealDetailAdvanceMoney)
				END
				ELSE
				BEGIN
					INSERT INTO @DetailTable (GroupID, MaterialID, OrderNumber, CheckOutPrice, DetailPrice, OrderRemark, NoProduce, RequestAdvanceMoney, MealDetailAdvanceMoney)
					VALUES(@GroupID, @MaterialID, @OrderNumber - @OldOrderNumber, @CheckOutPrice, 0, @OrderRemark, 0, @RequestAdvanceMoney, @MealDetailAdvanceMoney)
					
					INSERT INTO @DetailTable (GroupID, MaterialID, OrderNumber, CheckOutPrice, DetailPrice, OrderRemark, NoProduce, RequestAdvanceMoney, MealDetailAdvanceMoney)
					VALUES(@GroupID, @MaterialID, @OldOrderNumber, @CheckOutPrice, 0, @OrderRemark, 1, @RequestAdvanceMoney, @MealDetailAdvanceMoney)
				END
			END
			ELSE
			BEGIN
				INSERT INTO @DetailTable (GroupID, MaterialID, OrderNumber, CheckOutPrice, DetailPrice, OrderRemark, RequestAdvanceMoney, MealDetailAdvanceMoney)
				VALUES(@GroupID, @MaterialID, @OrderNumber, @CheckOutPrice, 0, @OrderRemark, @RequestAdvanceMoney, @MealDetailAdvanceMoney)
			END
			
		END
		
		
		SELECT @AdvanceMoneyTotal = sum(RequestAdvanceMoney + MealDetailAdvanceMoney)
		FROM @DetailTable
		
		SET @AdvanceMoneyTotal = ISNULL(@AdvanceMoneyTotal,0)
		
		--ƷζӼ۽	
		SET @AdvanceMoneyTotal = ABS(ROUND(@AdvanceMoneyTotal/@MealOrderNumber,2))
	
		--ƷӼҪӵƷյCheckOutPrice
		UPDATE BL_TBL_WineList_Detail
		SET CheckOutPrice = CheckOutPrice + @AdvanceMoneyTotal,
		    ProfitPrice = ProfitPrice + @AdvanceMoneyTotal
		WHERE WineListDetailID = @ParentWineListDetailID AND WineListType IN (0,5,6)
		
		SELECT @ParentTotalMoney = ProfitPrice * OrderNumber
		FROM BL_TBL_WineList_Detail
		WHERE WineListDetailID = @ParentWineListDetailID 
		    AND PresentStatus = 1  --Ʒ
		    AND SignArtificial = 1  --Ʒ
		
		--ƷƷҪݱʼ̯ۼ
		IF @ParentSignArtificial = 1
		BEGIN
			SELECT @ChildTotalMoney = SUM(OrderNumber * CheckOutPrice) FROM @DetailTable
			IF ISNULL(@ChildTotalMoney, 0) > 0
			BEGIN
				UPDATE @DetailTable 
				SET DetailPrice = CheckOutPrice * @MealParentTotalMoney / @ChildTotalMoney
				
				--Ʒķ̯۸ҪӼ
				UPDATE @DetailTable 
				SET DetailPrice = DetailPrice + (RequestAdvanceMoney+MealDetailAdvanceMoney)/OrderNumber
				
				--ѲСһƷ
				SELECT @ChildTotalMoney = SUM(OrderNumber * DetailPrice) FROM @DetailTable
				IF @ChildTotalMoney <> @ParentTotalMoney
				BEGIN
					SELECT TOP 1 @KeyID = KeyID, @OrderNumber = OrderNumber
					  FROM @DetailTable WHERE CheckOutPrice > 0 ORDER BY OrderNumber ASC
					
					UPDATE @DetailTable 
					SET DetailPrice = DetailPrice + (@ParentTotalMoney - @ChildTotalMoney) / @OrderNumber
					WHERE KeyID = @KeyID
				END
			END
		END
		
		DECLARE Cur_DetailList CURSOR LOCAL FOR
		SELECT GroupID, MaterialID, OrderNumber, CheckOutPrice, DetailPrice, OrderRemark, NoProduce, RequestAdvanceMoney, MealDetailAdvanceMoney FROM @DetailTable
		
		OPEN Cur_DetailList
		FETCH NEXT FROM Cur_DetailList INTO @GroupID, @MaterialID, @OrderNumber, @CheckOutPrice, @DetailPrice, @OrderRemark, @NoProduce, @RequestAdvanceMoney, @MealDetailAdvanceMoney
		WHILE @@FETCH_STATUS = 0
		BEGIN
		    SET @RequestAdvanceMoney = ISNULL(@RequestAdvanceMoney, 0)
		    SET @MealDetailAdvanceMoney = ISNULL(@MealDetailAdvanceMoney, 0)
			--ȡƷƷʽIDƷIPƷֿID
			EXEC BL_HV_GetWineProduceInfo
				@MachineIP,  --㵥IP
				@MaterialID,  --ƷID
				@RoomID,  --ID
				@ProduceTypeID OUTPUT,  --ƷʽID
				@ProduceIP OUTPUT,  --ƷIP
				@StorageID OUTPUT,  --ֿID
				@ErrorCode OUTPUT,
				@ErrorMessage OUTPUT,
				@ExceptMessage OUTPUT
			
			IF @ErrorCode <> 0
			BEGIN
				IF (@@TRANCOUNT > 1) AND (XACT_STATE() = 1)
					COMMIT TRAN 
				ELSE
				IF  (XACT_STATE() <> 0)
					ROLLBACK TRAN 
				
				RETURN @ErrorCode
			END
			ELSE
				SET @ErrorCode = -1
			
			--֤ƷЧ
			EXEC BL_HV_ValidateOrderWine
				@RoomID,
				@CheckOutID,
				0,--@WineListDetailID INT,
				@MachineIP,
				@AppTag,
				@MaterialID,
				@OrderNumber,
				2,--@PresentStatus INT,
				@PriceTypeID,
				0,--@CheckOutPrice,
				0,--@SignEditPrice TINYINT,  --1ʾֶ޸ļ۸䵥ύʱҪУ۸Ч
				@StorageID,
				0,--@PresentSign,  --ƷҪ֤ͷΧ
				0,--@PresentStaffID,
				@WineListType,
				@ErrorCode OUTPUT,
				@ErrorMessage OUTPUT,
				@ExceptMessage OUTPUT
			
			IF @ErrorCode <> 0
			BEGIN
				IF (@@TRANCOUNT > 1) AND (XACT_STATE() = 1)
					COMMIT TRAN 
				ELSE
				IF  (XACT_STATE() <> 0)
					ROLLBACK TRAN 
				
				RETURN @ErrorCode
			END
			ELSE
				SET @ErrorCode = -1
			
			--뵽ʱ
			EXEC BL_HV_OrderWineTempIns
				@WineListID OUTPUT,
				@WineListDetailID OUTPUT,
				@MachineIP,
				@AppTag,
				@RoomID,
				@CheckOutID,
				@CheckActivityID,  --˵IDƷʱҪ¼
				@MaterialID,
				@OrderNumber,
				@PriceTypeID,
				@CheckOutPrice,
				@DetailPrice,
				0,--@SignEditPrice TINYINT,
				@WineListType,
				@PresentSign,
				@PresentManID,
				@ProduceTypeID,
				@ProduceIP,
				@StorageID,
				2,--@PresentStatus,
				@OrderRemark,
				@WinePresentSetID,
				@GroupID,
				@ParentWineListDetailID,
				0,--@PresentSetUsedNumber,  --ʹ
				@ErrorCode OUTPUT,
				@ErrorMessage OUTPUT,
				@ExceptMessage OUTPUT,
				N'',
				@WineCardID,
				@HungStatus,
				0,
				@NoProduce,
				0,
				0,
				@RequestAdvanceMoney,
				@MealDetailAdvanceMoney
				
			IF @ErrorCode <> 0
			BEGIN
				IF (@@TRANCOUNT > 1) AND (XACT_STATE() = 1)
					COMMIT TRAN 
				ELSE
				IF  (XACT_STATE() <> 0)
					ROLLBACK TRAN 
				
				RETURN @ErrorCode
			END
			ELSE
				SET @ErrorCode = -1				
					
			FETCH NEXT FROM Cur_DetailList INTO @GroupID, @MaterialID, @OrderNumber, @CheckOutPrice, @DetailPrice, @OrderRemark, @NoProduce, @RequestAdvanceMoney, @MealDetailAdvanceMoney
		END
		
		CLOSE Cur_DetailList
		DEALLOCATE Cur_DetailList

		COMMIT TRAN
		SET @ErrorCode = 0
		RETURN @ErrorCode
		
	END TRY
	BEGIN CATCH
		IF (@@TRANCOUNT > 1) AND (XACT_STATE() = 1)
			COMMIT TRAN 
		ELSE
		IF  (XACT_STATE() <> 0)
			ROLLBACK TRAN 
		 
		SET @ErrorCode = ERROR_NUMBER()
		SET @ErrorMessage = N'ִй[BL_HV_PresentDetailSaveToTemp]ʧ'
		SET @ExceptMessage = ERROR_MESSAGE()

	END CATCH
END
GO
